Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/UIMonitorCommon.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/UIMonitorCommon.cpp	(revision 83508)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/UIMonitorCommon.cpp	(revision 83509)
@@ -181,4 +181,7 @@
                                const QRectF &chartRect, const QRectF &innerRect, int iOverlayAlpha)
 {
+    (void)data2;
+    (void)data2Color;
+    (void)iOverlayAlpha;
     /* Draw two arcs. one for the inner the other for the outer circle: */
     painter.setPen(QPen(QColor(100, 100, 100, iOverlayAlpha), 1));
@@ -201,2 +204,35 @@
     painter.drawPath(doughnutSlice(chartRect, innerRect, 90 - fAngle, fAngle2));
 }
+
+/* static */
+QRectF UIMonitorCommon::getScaledRect(const QRectF &outerFrame, float fScaleX, float fScaleY)
+{
+    if (!outerFrame.isValid())
+        return QRectF();
+    QPointF center = outerFrame.center();
+    float iWidth = fScaleX * outerFrame.width();
+    float iHeight = fScaleY * outerFrame.height();
+    return QRectF(QPointF(center.x() - 0.5 * iWidth, center.y() - 0.5 * iHeight),
+                 QSizeF(iWidth, iHeight));
+}
+
+/* static */
+void UIMonitorCommon::drawDoughnutChart(QPainter &painter, quint64 iMaximum, quint64 data,
+                                        const QRectF &chartRect, const QRectF &innerRect, int iOverlayAlpha, const QColor &color)
+{
+    /* Draw a whole non-filled circle: */
+    painter.setPen(QPen(QColor(100, 100, 100, iOverlayAlpha), 1));
+    painter.drawArc(chartRect, 0, 3600 * 16);
+    painter.drawArc(innerRect, 0, 3600 * 16);
+
+    /* Draw a white filled circle and the arc for data: */
+    QPainterPath background = UIMonitorCommon::wholeArc(chartRect).subtracted(UIMonitorCommon::wholeArc(innerRect));
+    painter.setPen(Qt::NoPen);
+    painter.setBrush(QColor(255, 255, 255, iOverlayAlpha));
+    painter.drawPath(background);
+
+    /* Draw the doughnut slice for the data: */
+    float fAngle = 360.f * data / (float)iMaximum;
+    painter.setBrush(color);
+    painter.drawPath(UIMonitorCommon::doughnutSlice(chartRect, innerRect, 90, fAngle));
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/UIMonitorCommon.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/UIMonitorCommon.h	(revision 83508)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/UIMonitorCommon.h	(revision 83509)
@@ -57,4 +57,9 @@
                                               const QRectF &chartRect, const QRectF &innerRect, int iOverlayAlpha);
 
+        /* Returns a rectangle which is co-centric with @p outerFrame and scaled by @p fScaleX and fScaleY. */
+        static QRectF getScaledRect(const QRectF &outerFrame, float fScaleX, float fScaleY);
+
+        static void drawDoughnutChart(QPainter &painter, quint64 iMaximum, quint64 data,
+                                      const QRectF &chartRect, const QRectF &innerRect, int iOverlayAlpha, const QColor &color);
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.cpp	(revision 83508)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.cpp	(revision 83509)
@@ -106,6 +106,4 @@
        void drawPieChart(QPainter &painter, quint64 iMaximum, int iDataIndex, const QRectF &chartRect, bool fWithBorder = true);
        void drawCombinedPieCharts(QPainter &painter, quint64 iMaximum);
-       void drawDoughnutChart(QPainter &painter, quint64 iMaximum, int iDataIndex,
-                              const QRectF &chartRect, const QRectF &innerRect);
 
        /** Drawing an overlay rectangle over the charts to indicate that they are disabled. */
@@ -481,28 +479,4 @@
 }
 
-void UIChart::drawDoughnutChart(QPainter &painter, quint64 iMaximum, int iDataIndex,
-                                const QRectF &chartRect, const QRectF &innerRect)
-{
-    const QQueue<quint64> *data = m_pMetric->data(iDataIndex);
-    if (!data || data->isEmpty())
-        return;
-
-    /* Draw a whole non-filled circle: */
-    painter.setPen(QPen(QColor(100, 100, 100, m_iOverlayAlpha), 1));
-    painter.drawArc(chartRect, 0, 3600 * 16);
-    painter.drawArc(innerRect, 0, 3600 * 16);
-
-    /* Draw a white filled circle and the arc for data: */
-    QPainterPath background = UIMonitorCommon::wholeArc(chartRect).subtracted(UIMonitorCommon::wholeArc(innerRect));
-    painter.setPen(Qt::NoPen);
-    painter.setBrush(QColor(255, 255, 255, m_iOverlayAlpha));
-    painter.drawPath(background);
-
-    /* Draw the doughnut slice for the data: */
-    float fAngle = 360.f * data->back() / (float)iMaximum;
-    painter.setBrush(conicalGradientForDataSeries(chartRect, iDataIndex));
-    painter.drawPath(UIMonitorCommon::doughnutSlice(chartRect, innerRect, 90, fAngle));
-}
-
 QConicalGradient UIChart::conicalGradientForDataSeries(const QRectF &rectangle, int iDataIndex)
 {
@@ -530,15 +504,15 @@
     if (fData0 && fData1)
     {
-        QRectF innerRect(QPointF(chartRect.left() + 0.25 * chartRect.width(), chartRect.top() + 0.25 * chartRect.height()),
-                         QSizeF(0.5 * chartRect.width(), 0.5 * chartRect.height()));
         /* Draw a doughnut chart where data series are stacked on to of each other: */
         if (m_pMetric->data(0) && !m_pMetric->data(0)->isEmpty() &&
             m_pMetric->data(1) && !m_pMetric->data(1)->isEmpty())
-            UIMonitorCommon::drawCombinedDoughnutChart(m_pMetric->data(0)->back(), dataSeriesColor(0, 50),
-                                                       m_pMetric->data(1)->back(), dataSeriesColor(1, 50),
-                                                       painter, iMaximum, chartRect, innerRect, m_iOverlayAlpha);
+            UIMonitorCommon::drawCombinedDoughnutChart(m_pMetric->data(1)->back(), dataSeriesColor(1, 50),
+                                                       m_pMetric->data(0)->back(), dataSeriesColor(0, 50),
+                                                       painter, iMaximum, chartRect,
+                                                       UIMonitorCommon::getScaledRect(chartRect, 0.5f, 0.5f), m_iOverlayAlpha);
 #if 0
         /* Draw a doughnut shaped chart and then pie chart inside it: */
-        drawDoughnutChart(painter, iMaximum, 0 /* iDataIndex */, chartRect, innerRect);
+        UIMonitorCommon::drawDoughnutChart(painter, iMaximum, m_pMetric->data(0)->back(),
+                                           chartRect, innerRect, m_iOverlayAlpha, dataSeriesColor(0));
         drawPieChart(painter, iMaximum, 1 /* iDataIndex */, innerRect, false);
 #endif
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.cpp	(revision 83508)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.cpp	(revision 83509)
@@ -21,5 +21,7 @@
 #include <QHeaderView>
 #include <QItemDelegate>
+#include <QLabel>
 #include <QMenuBar>
+#include <QPainter>
 #include <QPushButton>
 #include <QTableView>
@@ -61,4 +63,53 @@
 };
 
+///#define DEBUG_BACKGROUND
+/*********************************************************************************************************************************
+*   Class UIVMResourceMonitorHostStats definition.                                                                           *
+*********************************************************************************************************************************/
+
+class UIVMResourceMonitorHostStats
+{
+
+public:
+
+    UIVMResourceMonitorHostStats();
+    quint64 m_iCPUUserLoad;
+    quint64 m_iCPUKernelLoad;
+    quint64 m_iCPUFreq;
+    quint64 m_iTotalRAM;
+    quint64 m_iFreeRAM;
+};
+
+
+/*********************************************************************************************************************************
+*   Class UIVMResourceMonitorHostCPUWidget definition.                                                                           *
+*********************************************************************************************************************************/
+
+class UIVMResourceMonitorHostCPUWidget : public QWidget
+{
+
+    Q_OBJECT;
+
+public:
+
+    UIVMResourceMonitorHostCPUWidget(QWidget *pParent = 0);
+    void setCPULoad(quint64 iUserLoad, quint64 iKernelLoad, quint64 iCPUFreq);
+    void setChartColors(const QColor &CPUUserLoadColor, const QColor &CPUKernelLoadColor);
+
+protected:
+
+    virtual void paintEvent(QPaintEvent *pEvent) /* override */;
+
+private:
+
+    quint64 m_iCPUUserLoad;
+    quint64 m_iCPUKernelLoad;
+    quint64 m_iCPUFreq;
+    int m_iMinimumHeight;
+    int m_iMargin;
+    QColor m_CPUUserColor;
+    QColor m_CPUKernelColor;
+};
+
 
 /*********************************************************************************************************************************
@@ -66,14 +117,31 @@
 *********************************************************************************************************************************/
 
-class UIVMResourceMonitorHostStatsWidget : public QWidget
+class UIVMResourceMonitorHostStatsWidget : public QIWithRetranslateUI<QWidget>
 {
 
     Q_OBJECT;
 
-
 public:
 
     UIVMResourceMonitorHostStatsWidget(QWidget *pParent = 0);
-
+    void setHostStats(const UIVMResourceMonitorHostStats &hostStats);
+
+protected:
+
+    virtual void retranslateUi() /* override */;
+
+private:
+
+    void prepare();
+    void updateLabels();
+
+    UIVMResourceMonitorHostCPUWidget   *m_pHostCPUChart;
+    QLabel                             *m_pCPUTitleLabel;
+    QLabel                             *m_pCPUUserLabel;
+    QLabel                             *m_pCPUKernelLabel;
+    QLabel                             *m_pCPUTotalLabel;
+    QColor                              m_CPUUserColor;
+    QColor                              m_CPUKernelColor;
+    UIVMResourceMonitorHostStats        m_hostStats;
 };
 
@@ -150,20 +218,4 @@
 
 /*********************************************************************************************************************************
-*   Class UIVMResourceMonitorHostStats definition.                                                                           *
-*********************************************************************************************************************************/
-
-class UIVMResourceMonitorHostStats
-{
-
-public:
-
-    UIVMResourceMonitorHostStats();
-    quint64 m_fCPUUserLoad;
-    quint64 m_fCPUKernelLoad;
-    quint64 m_iTotalRAM;
-    quint64 m_iFreeRAM;
-};
-
-/*********************************************************************************************************************************
 *   Class UIVMResourceMonitorCheckBox definition.                                                                           *
 *********************************************************************************************************************************/
@@ -221,4 +273,5 @@
 
     void sigDataUpdate();
+    void sigHostStatsUpdate(const UIVMResourceMonitorHostStats &stats);
 
 public:
@@ -283,11 +336,148 @@
 
 /*********************************************************************************************************************************
+*   Class UIVMResourceMonitorHostCPUWidget implementation.                                                                       *
+*********************************************************************************************************************************/
+
+UIVMResourceMonitorHostCPUWidget::UIVMResourceMonitorHostCPUWidget(QWidget *pParent /* = 0 */)
+    :QWidget(pParent)
+    , m_iCPUUserLoad(0)
+    , m_iCPUKernelLoad(0)
+    , m_iCPUFreq(0)
+{
+    m_iMargin = 3;
+    m_iMinimumHeight =  3 * QApplication::style()->pixelMetric(QStyle::PM_LargeIconSize);
+    setMinimumSize(m_iMinimumHeight, m_iMinimumHeight);
+}
+
+void UIVMResourceMonitorHostCPUWidget::setCPULoad(quint64 iUserLoad, quint64 iKernelLoad, quint64 iFreq)
+{
+    m_iCPUUserLoad = iUserLoad;
+    m_iCPUKernelLoad = iKernelLoad;
+    m_iCPUFreq = iFreq;
+    update();
+}
+
+void UIVMResourceMonitorHostCPUWidget::setChartColors(const QColor &CPUUserLoadColor, const QColor &CPUKernelLoadColor)
+{
+    m_CPUUserColor = CPUUserLoadColor;
+    m_CPUKernelColor = CPUKernelLoadColor;
+}
+
+void UIVMResourceMonitorHostCPUWidget::paintEvent(QPaintEvent *pEvent)
+{
+    QWidget::paintEvent(pEvent);
+
+    QPainter painter(this);
+    painter.setRenderHint(QPainter::Antialiasing);
+
+    int iFrameHeight = m_iMinimumHeight - 2 * m_iMargin;
+    QRectF outerRect = QRectF(QPoint(m_iMargin,m_iMargin), QSize(iFrameHeight, iFrameHeight));
+    QRectF innerRect = UIMonitorCommon::getScaledRect(outerRect, 0.6f, 0.6f);
+    UIMonitorCommon::drawCombinedDoughnutChart(m_iCPUKernelLoad, m_CPUKernelColor,
+                                               m_iCPUUserLoad, m_CPUUserColor,
+                                               painter, 100,
+                                               outerRect, innerRect, 80);
+    float mul = 1.f / 1.4f;
+    QRectF textRect =  UIMonitorCommon::getScaledRect(innerRect, mul, mul);
+    painter.setPen(Qt::black);
+    painter.drawText(textRect, Qt::AlignCenter, QString("%1\nMHz").arg(QString::number(m_iCPUFreq)));
+}
+
+
+/*********************************************************************************************************************************
 *   Class UIVMResourceMonitorHostStatsWidget implementation.                                                                     *
 *********************************************************************************************************************************/
 
 UIVMResourceMonitorHostStatsWidget::UIVMResourceMonitorHostStatsWidget(QWidget *pParent /* = 0 */)
-    :QWidget(pParent)
-{
-}
+    : QIWithRetranslateUI<QWidget>(pParent)
+    , m_pHostCPUChart(0)
+    , m_pCPUTitleLabel(0)
+    , m_pCPUUserLabel(0)
+    , m_pCPUKernelLabel(0)
+    , m_pCPUTotalLabel(0)
+    , m_CPUUserColor(Qt::red)
+    , m_CPUKernelColor(Qt::blue)
+{
+    prepare();
+    retranslateUi();
+#ifdef DEBUG_BACKGROUND
+    QPalette pal = palette();
+    pal.setColor(QPalette::Background, Qt::red);
+    setAutoFillBackground(true);
+    setPalette(pal);
+#endif
+}
+
+void UIVMResourceMonitorHostStatsWidget::setHostStats(const UIVMResourceMonitorHostStats &hostStats)
+{
+    m_hostStats = hostStats;
+    if (m_pHostCPUChart)
+        m_pHostCPUChart->setCPULoad(m_hostStats.m_iCPUUserLoad, m_hostStats.m_iCPUKernelLoad, m_hostStats.m_iCPUFreq);
+    updateLabels();
+}
+
+void UIVMResourceMonitorHostStatsWidget::retranslateUi()
+{
+    updateLabels();
+}
+
+void UIVMResourceMonitorHostStatsWidget::prepare()
+{
+    QHBoxLayout *pLayout = new QHBoxLayout;
+    setLayout(pLayout);
+
+    /* Host CPU Labels: */
+    QWidget *pCPULabelContainer = new QWidget;
+    pCPULabelContainer->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Maximum);
+
+#ifdef DEBUG_BACKGROUND
+    QPalette pal = pCPULabelContainer->palette();
+    pal.setColor(QPalette::Background, Qt::yellow);
+    pCPULabelContainer->setAutoFillBackground(true);
+    pCPULabelContainer->setPalette(pal);
+#endif
+    pLayout->addWidget(pCPULabelContainer);
+    QVBoxLayout *pCPULabelsLayout = new QVBoxLayout;
+    pCPULabelsLayout->setContentsMargins(0, 0, 0, 0);
+    pCPULabelContainer->setLayout(pCPULabelsLayout);
+    m_pCPUTitleLabel = new QLabel;
+    pCPULabelsLayout->addWidget(m_pCPUTitleLabel);
+    m_pCPUUserLabel = new QLabel;
+    pCPULabelsLayout->addWidget(m_pCPUUserLabel);
+    m_pCPUKernelLabel = new QLabel;
+    pCPULabelsLayout->addWidget(m_pCPUKernelLabel);
+    m_pCPUTotalLabel = new QLabel;
+    pCPULabelsLayout->addWidget(m_pCPUTotalLabel);
+    pCPULabelsLayout->setAlignment(Qt::AlignTop);
+    //pLayout->setAlignment(Qt::AlignTop);
+    pCPULabelsLayout->setSpacing(0);
+    /* Host CPU chart widget: */
+    m_pHostCPUChart = new UIVMResourceMonitorHostCPUWidget;
+    if (m_pHostCPUChart)
+    {
+        pLayout->addWidget(m_pHostCPUChart);
+        m_pHostCPUChart->setChartColors(m_CPUUserColor, m_CPUKernelColor);
+    }
+    pLayout->addStretch(2);
+}
+
+void UIVMResourceMonitorHostStatsWidget::updateLabels()
+{
+    if (m_pCPUTitleLabel)
+        m_pCPUTitleLabel->setText(QString("<b>%1</b>").arg(tr("Host CPU Load")));
+    if (m_pCPUUserLabel)
+    {
+        QString strColor = QColor(m_CPUUserColor).name(QColor::HexRgb);
+        m_pCPUUserLabel->setText(QString("<font color=\"%1\">%2:%3%</font>").arg(strColor).arg(tr("User")).arg(QString::number(m_hostStats.m_iCPUUserLoad)));
+    }
+    if (m_pCPUKernelLabel)
+    {
+        QString strColor = QColor(m_CPUKernelColor).name(QColor::HexRgb);
+        m_pCPUKernelLabel->setText(QString("<font color=\"%1\">%2:%3%</font>").arg(strColor).arg(tr("Kernel")).arg(QString::number(m_hostStats.m_iCPUKernelLoad)));
+    }
+    if (m_pCPUTotalLabel)
+        m_pCPUTotalLabel->setText(QString("%1:%2%").arg(tr("Total")).arg(m_hostStats.m_iCPUUserLoad + m_hostStats.m_iCPUKernelLoad));
+}
+
 
 
@@ -445,6 +635,7 @@
 
 UIVMResourceMonitorHostStats::UIVMResourceMonitorHostStats()
-    : m_fCPUUserLoad(0)
-    , m_fCPUKernelLoad(0)
+    : m_iCPUUserLoad(0)
+    , m_iCPUKernelLoad(0)
+    , m_iCPUFreq(0)
     , m_iTotalRAM(0)
     , m_iFreeRAM(0)
@@ -698,5 +889,4 @@
                 m_itemList[i].m_uCPUVMMLoad = aPctVMM;
             }
-
             /* Network rate: */
             if (fNetworkColumns)
@@ -709,5 +899,4 @@
                 m_itemList[i].m_uNetworkUpRate = m_itemList[i].m_uNetworkUpTotal - uPrevUpTotal;
             }
-
             /* IO rate: */
             if (fIOColumns)
@@ -720,5 +909,4 @@
                 m_itemList[i].m_uDiskReadRate = m_itemList[i].m_uDiskReadTotal - uPrevReadTotal;
             }
-
            /* VM Exits: */
            if (fVMExitColumn)
@@ -731,4 +919,5 @@
     }
     emit sigDataUpdate();
+    emit sigHostStatsUpdate(m_hostStats);
 }
 
@@ -745,6 +934,6 @@
         m_nameList << "Guest/RAM/Usage*";
     /* This is for the host: */
-    m_nameList << "CPU/Load/User:avg";
-    m_nameList << "CPU/Load/Kernel:avg";
+    m_nameList << "CPU*";
+    //m_nameList << "CPU/Load/Kernel*";
     m_objectList = QVector<CUnknown>(m_nameList.size(), CUnknown());
     m_performanceMonitor.SetupMetrics(m_nameList, m_objectList, iPeriod, iMetricSetupCount);
@@ -795,16 +984,23 @@
             }
         }
-        else if (aReturnNames[i].contains("CPU/Load/User", Qt::CaseInsensitive))
+        else if (aReturnNames[i].contains("CPU/Load/User", Qt::CaseInsensitive) && !aReturnNames[i].contains(":"))
         {
             CHost comHost = (CHost)aReturnObjects[i];
             if (!comHost.isNull())
-                m_hostStats.m_fCPUUserLoad = fData;
+                m_hostStats.m_iCPUUserLoad = fData;
         }
-        else if (aReturnNames[i].contains("CPU/Load/Kernel", Qt::CaseInsensitive))
+        else if (aReturnNames[i].contains("CPU/Load/Kernel", Qt::CaseInsensitive) && !aReturnNames[i].contains(":"))
         {
             CHost comHost = (CHost)aReturnObjects[i];
             if (!comHost.isNull())
-                m_hostStats.m_fCPUKernelLoad = fData;
+                m_hostStats.m_iCPUKernelLoad = fData;
         }
+        else if (aReturnNames[i].contains("CPU/MHz", Qt::CaseInsensitive) && !aReturnNames[i].contains(":"))
+        {
+            CHost comHost = (CHost)aReturnObjects[i];
+            if (!comHost.isNull())
+                m_hostStats.m_iCPUFreq = fData;
+        }
+
     }
     for (int i = 0; i < m_itemList.size(); ++i)
@@ -857,4 +1053,5 @@
     , m_pProxyModel(0)
     , m_pModel(0)
+    , m_pHostStatsWidget(0)
     , m_pColumnSelectionMenu(0)
     , m_fIsCurrentTool(true)
@@ -961,4 +1158,8 @@
     if (m_fShowToolbar)
         prepareToolBar();
+
+    m_pHostStatsWidget = new UIVMResourceMonitorHostStatsWidget;
+    if (m_pHostStatsWidget)
+        layout()->addWidget(m_pHostStatsWidget);
 
     m_pModel = new UIResourceMonitorModel(this);
@@ -989,5 +1190,5 @@
         m_pTableView->sortByColumn(0, Qt::AscendingOrder);
         connect(m_pModel, &UIResourceMonitorModel::sigDataUpdate, this, &UIResourceMonitorWidget::sltHandleDataUpdate);
-
+        connect(m_pModel, &UIResourceMonitorModel::sigHostStatsUpdate, this, &UIResourceMonitorWidget::sltHandleHostStatsUpdate);
         updateModelColumVisibilityCache();
     }
@@ -1102,4 +1303,10 @@
 }
 
+void UIResourceMonitorWidget::sltHandleHostStatsUpdate(const UIVMResourceMonitorHostStats &stats)
+{
+    if (m_pHostStatsWidget)
+        m_pHostStatsWidget->setHostStats(stats);
+}
+
 void UIResourceMonitorWidget::sltHandleDataUpdate()
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.h	(revision 83508)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.h	(revision 83509)
@@ -32,4 +32,5 @@
 class QAbstractButton;
 class QFrame;
+class QLabel;
 class QTableView;
 class QTreeWidgetItem;
@@ -39,4 +40,6 @@
 class UIResourceMonitorProxyModel;
 class UIResourceMonitorModel;
+class UIVMResourceMonitorHostStats;
+class UIVMResourceMonitorHostStatsWidget;
 class UIVMResourceMonitorTableView;
 
@@ -78,4 +81,5 @@
     void sltToggleColumnSelectionMenu(bool fChecked);
     void sltHandleColumnAction(bool fChecked);
+    void sltHandleHostStatsUpdate(const UIVMResourceMonitorHostStats &stats);
 
 private:
@@ -89,4 +93,5 @@
         void prepare();
         void prepareWidgets();
+        void prepareHostStatsWidgets();
         void prepareToolBar();
         void prepareActions();
@@ -106,10 +111,13 @@
       * @{ */
         UIToolBar *m_pToolBar;
-        UIVMResourceMonitorTableView *m_pTableView;
-        UIResourceMonitorProxyModel *m_pProxyModel;
-        UIResourceMonitorModel      *m_pModel;
-        QVector<QString>             m_columnCaptions;
+        UIVMResourceMonitorTableView       *m_pTableView;
+        UIResourceMonitorProxyModel        *m_pProxyModel;
+        UIResourceMonitorModel             *m_pModel;
+        QVector<QString>                    m_columnCaptions;
         /* The key is the column id (VMResourceMonitorColumn) and value is true if the column is visible. */
-        QMap<int, bool>              m_columnVisible;
+        QMap<int, bool>                     m_columnVisible;
+        UIVMResourceMonitorHostStatsWidget *m_pHostStatsWidget;
+
+
     /** @} */
     QFrame *m_pColumnSelectionMenu;