Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp	(revision 83654)
@@ -28,10 +28,10 @@
 }
 
-QList<UICloudMachine> UITaskCloudAcquireInstances::result() const
+QVector<CCloudMachine> UITaskCloudAcquireInstances::result() const
 {
     m_mutex.lock();
-    const QList<UICloudMachine> resultList = m_result;
+    const QVector<CCloudMachine> resultVector = m_result;
     m_mutex.unlock();
-    return resultList;
+    return resultVector;
 }
 
@@ -47,5 +47,5 @@
 {
     m_mutex.lock();
-    m_result = listInstances(m_comCloudClient, m_strErrorInfo);
+    m_result = listCloudMachines(m_comCloudClient, m_strErrorInfo);
     m_mutex.unlock();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h	(revision 83654)
@@ -26,5 +26,4 @@
 
 /* GUI includes: */
-#include "UICloudMachine.h"
 #include "UITask.h"
 
@@ -32,4 +31,5 @@
 #include "COMEnums.h"
 #include "CCloudClient.h"
+#include "CCloudMachine.h"
 
 /* Forward declaratiuons: */
@@ -57,5 +57,5 @@
 
     /** Returns the task result. */
-    QList<UICloudMachine> result() const;
+    QVector<CCloudMachine> result() const;
 
 protected:
@@ -78,5 +78,5 @@
 
     /** Holds the task result. */
-    QList<UICloudMachine>  m_result;
+    QVector<CCloudMachine>  m_result;
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudGetInstanceInfo.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudGetInstanceInfo.cpp	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudGetInstanceInfo.cpp	(revision 83654)
@@ -17,10 +17,11 @@
 
 /* GUI includes: */
+#include "UICloudNetworkingStuff.h"
 #include "UITaskCloudGetInstanceInfo.h"
 
 
-UITaskCloudGetInstanceInfo::UITaskCloudGetInstanceInfo(const UICloudMachine &guiCloudMachine)
+UITaskCloudGetInstanceInfo::UITaskCloudGetInstanceInfo(const CCloudMachine &comCloudMachine)
     : UITask(Type_CloudGetInstanceState)
-    , m_guiCloudMachine(guiCloudMachine)
+    , m_comCloudMachine(comCloudMachine)
 {
 }
@@ -37,5 +38,5 @@
 {
     m_mutex.lock();
-    m_guiCloudMachine.refresh();
+    refreshCloudMachineInfo(m_comCloudMachine, m_strErrorInfo);
     m_mutex.unlock();
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudGetInstanceInfo.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudGetInstanceInfo.h	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudGetInstanceInfo.h	(revision 83654)
@@ -27,6 +27,9 @@
 
 /* GUI includes: */
-#include "UICloudMachine.h"
 #include "UITask.h"
+
+/* COM includes: */
+#include "COMEnums.h"
+#include "CCloudMachine.h"
 
 
@@ -38,7 +41,7 @@
 public:
 
-    /** Constructs task taking @a guiCloudMachine as data.
-      * @param  guiCloudMachine  Brings the cloud VM wrapper. */
-    UITaskCloudGetInstanceInfo(const UICloudMachine &guiCloudMachine);
+    /** Constructs task taking @a comCloudMachine as data.
+      * @param  comCloudMachine  Brings the cloud VM wrapper. */
+    UITaskCloudGetInstanceInfo(const CCloudMachine &comCloudMachine);
 
     /** Returns error info. */
@@ -52,9 +55,9 @@
 private:
 
-    /** Holds the mutex to access m_guiCloudMachine member. */
+    /** Holds the mutex to access m_comCloudMachine member. */
     mutable QMutex  m_mutex;
 
-    /** Holds the cloud client object. */
-    UICloudMachine  m_guiCloudMachine;
+    /** Holds the cloud machine object. */
+    CCloudMachine  m_comCloudMachine;
 
     /** Holds the error info. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp	(revision 83654)
@@ -41,7 +41,7 @@
 }
 
-UIVirtualMachineItemCloud::UIVirtualMachineItemCloud(const UICloudMachine &guiCloudMachine)
+UIVirtualMachineItemCloud::UIVirtualMachineItemCloud(const CCloudMachine &comCloudMachine)
     : UIVirtualMachineItem(ItemType_CloudReal)
-    , m_guiCloudMachine(guiCloudMachine)
+    , m_comCloudMachine(comCloudMachine)
     , m_enmFakeCloudItemState(FakeCloudItemState_NotApplicable)
     , m_pTask(0)
@@ -71,15 +71,12 @@
 void UIVirtualMachineItemCloud::pauseOrResume(bool fPause, QWidget *pParent)
 {
-    /* Acquire cloud client: */
-    CCloudClient comCloudClient = m_guiCloudMachine.client();
-
-    /* Now execute async method: */
+    /* Execute async method: */
     CProgress comProgress;
     if (fPause)
-        comProgress = comCloudClient.PauseInstance(m_strInstanceId);
-    else
-        comProgress = comCloudClient.StartInstance(m_strInstanceId);
-    if (!comCloudClient.isOk())
-        msgCenter().cannotAcquireCloudClientParameter(comCloudClient);
+        comProgress = m_comCloudMachine.PowerDown();
+    else
+        comProgress = m_comCloudMachine.PowerUp();
+    if (!m_comCloudMachine.isOk())
+        msgCenter().cannotAcquireCloudMachineParameter(m_comCloudMachine);
     else
     {
@@ -102,27 +99,26 @@
 {
     /* Determine attributes which are always available: */
-    if (!m_guiCloudMachine.isNull())
-    {
-        m_strInstanceId = m_guiCloudMachine.instanceId();
-        m_strName = m_guiCloudMachine.instanceName();
-        m_uId = m_guiCloudMachine.id();
+    if (!m_comCloudMachine.isNull())
+    {
+        m_uId = m_comCloudMachine.GetId();
+        m_strName = m_comCloudMachine.GetName();
     }
 
     /* Now determine whether VM is accessible: */
-    m_fAccessible = !m_guiCloudMachine.isNull()
-                  ? m_guiCloudMachine.accessible()
-                  : true;
-    m_strAccessError = !m_guiCloudMachine.isNull()
-                     ? m_guiCloudMachine.accessError()
-                     : QString();
+    m_fAccessible = /*!m_comCloudMachine.isNull()
+                  ? m_comCloudMachine.accessible()
+                  : */true;
+    m_strAccessError = /*!m_comCloudMachine.isNull()
+                     ? m_comCloudMachine.accessError()
+                     : */QString();
 
     /* Determine own VM attributes: */
-    m_strOSTypeId = !m_guiCloudMachine.isNull()
-                  ? m_guiCloudMachine.osType()
+    m_strOSTypeId = !m_comCloudMachine.isNull()
+                  ? m_comCloudMachine.GetOSTypeId()
                   : "Other";
 
     /* Determine VM states: */
-    m_enmMachineState = !m_guiCloudMachine.isNull()
-                      ? m_guiCloudMachine.machineState()
+    m_enmMachineState = !m_comCloudMachine.isNull()
+                      ? m_comCloudMachine.GetState()
                       : KMachineState_PoweredOff;
     m_strMachineStateName = gpConverter->toString(m_enmMachineState);
@@ -283,5 +279,5 @@
     if (!m_pTask)
     {
-        m_pTask = new UITaskCloudGetInstanceInfo(m_guiCloudMachine);
+        m_pTask = new UITaskCloudGetInstanceInfo(m_comCloudMachine);
         connect(uiCommon().threadPoolCloud(), &UIThreadPool::sigTaskComplete,
                 this, &UIVirtualMachineItemCloud::sltHandleGetCloudInstanceInfoDone);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h	(revision 83654)
@@ -23,6 +23,9 @@
 
 /* GUI includes: */
-#include "UICloudMachine.h"
 #include "UIVirtualMachineItem.h"
+
+/* COM includes: */
+#include "COMEnums.h"
+#include "CCloudMachine.h"
 
 /* Forward declarations: */
@@ -51,6 +54,6 @@
     /** Constructs fake cloud VM item. */
     UIVirtualMachineItemCloud();
-    /** Constructs real cloud VM item on the basis of taken @a guiCloudMachine. */
-    UIVirtualMachineItemCloud(const UICloudMachine &guiCloudMachine);
+    /** Constructs real cloud VM item on the basis of taken @a comCloudMachine. */
+    UIVirtualMachineItemCloud(const CCloudMachine &comCloudMachine);
     /** Destructs cloud VM item. */
     virtual ~UIVirtualMachineItemCloud();
@@ -58,6 +61,6 @@
     /** @name Arguments.
       * @{ */
-        /** Returns cached cloud VM object. */
-        UICloudMachine machine() const { return m_guiCloudMachine; }
+        /** Returns cached cloud machine object. */
+        CCloudMachine machine() const { return m_comCloudMachine; }
     /** @} */
 
@@ -131,12 +134,6 @@
     /** @name Arguments.
       * @{ */
-        /** Holds cached cloud VM object reference. */
-        UICloudMachine  m_guiCloudMachine;
-    /** @} */
-
-    /** @name Basic attributes.
-      * @{ */
-        /** Holds the cloud instance id. */
-        QString  m_strInstanceId;
+        /** Holds cached cloud machine object. */
+        CCloudMachine  m_comCloudMachine;
     /** @} */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83654)
@@ -29,5 +29,4 @@
 #include "UIVirtualMachineItem.h"
 #ifdef VBOX_GUI_WITH_CLOUD_VMS
-# include "UICloudMachine.h"
 # include "UITaskCloudAcquireInstances.h"
 # include "UIThreadPool.h"
@@ -39,4 +38,5 @@
 #ifdef VBOX_GUI_WITH_CLOUD_VMS
 # include "CCloudClient.h"
+# include "CCloudMachine.h"
 # include "CCloudProfile.h"
 # include "CCloudProvider.h"
@@ -297,7 +297,7 @@
     AssertReturnVoid(pFirstChildNodeMachine->cache()->itemType() == UIVirtualMachineItem::ItemType_CloudFake);
 
-    /* And if we have at least one cloud instance: */
-    const QList<UICloudMachine> instances = pAcquiringTask->result();
-    if (!instances.isEmpty())
+    /* And if we have at least one cloud machine: */
+    const QVector<CCloudMachine> machines = pAcquiringTask->result();
+    if (!machines.isEmpty())
     {
         /* Remove the "Empty" node: */
@@ -306,5 +306,5 @@
         /* Add real cloud VM nodes: */
         int iPosition = 0;
-        foreach (const UICloudMachine &guiCloudMachine, instances)
+        foreach (const CCloudMachine &comCloudMachine, machines)
         {
             /* Create new node: */
@@ -312,5 +312,5 @@
                                                                    false /* favorite */,
                                                                    iPosition++ /* position */,
-                                                                   guiCloudMachine);
+                                                                   comCloudMachine);
             /* Request async node update: */
             pNode->cache()->toCloud()->updateInfoAsync(false /* delayed? */);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 83654)
@@ -41,7 +41,7 @@
                                            bool fFavorite,
                                            int iPosition,
-                                           const UICloudMachine &guiCloudMachine)
+                                           const CCloudMachine &comCloudMachine)
     : UIChooserNode(pParent, fFavorite)
-    , m_pCache(new UIVirtualMachineItemCloud(guiCloudMachine))
+    , m_pCache(new UIVirtualMachineItemCloud(comCloudMachine))
 {
     /* Add to parent: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.h	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.h	(revision 83654)
@@ -26,6 +26,6 @@
 
 /* Forward declarations: */
-class UICloudMachine;
 class UIVirtualMachineItem;
+class CCloudMachine;
 class CMachine;
 
@@ -49,9 +49,9 @@
       * @param  fFavorite        Brings whether the node is favorite.
       * @param  iPosition        Brings initial node position.
-      * @param  guiCloudMachine  Brings cloud VM object. */
+      * @param  comCloudMachine  Brings COM cloud machine object. */
     UIChooserNodeMachine(UIChooserNode *pParent,
                          bool fFavorite,
                          int iPosition,
-                         const UICloudMachine &guiCloudMachine);
+                         const CCloudMachine &comCloudMachine);
     /** Constructs chooser node for fake cloud VM passing @a pParent to the base-class.
       * @param  fFavorite  Brings whether the node is favorite.
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsSet.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsSet.cpp	(revision 83653)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsSet.cpp	(revision 83654)
@@ -106,5 +106,5 @@
             {
                 /* Get cloud machine: */
-                m_cloudMachine = m_pMachineItem->toCloud()->machine();
+//                m_cloudMachine = m_pMachineItem->toCloud()->machine();
 
                 /* Compose a list of types to build: */