Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 83658)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 83659)
@@ -620,5 +620,5 @@
 	src/hostnetwork/UIHostNetworkManager.h \
 	src/manager/UIErrorPane.h \
-	src/manager/UITaskCloudAcquireInstances.h \
+	src/manager/UITaskCloudListMachines.h \
 	src/manager/UITaskCloudRefreshMachineInfo.h \
 	src/manager/UIToolPaneGlobal.h \
@@ -1071,5 +1071,5 @@
 	src/hostnetwork/UIHostNetworkUtils.cpp \
 	src/manager/UIErrorPane.cpp \
-	src/manager/UITaskCloudAcquireInstances.cpp \
+	src/manager/UITaskCloudListMachines.cpp \
 	src/manager/UITaskCloudRefreshMachineInfo.cpp \
 	src/manager/UIToolPaneGlobal.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp	(revision 83658)
+++ 	(revision )
@@ -1,51 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UITaskCloudAcquireInstances class implementation.
- */
-
-/*
- * Copyright (C) 2020 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-/* GUI includes: */
-#include "UICloudNetworkingStuff.h"
-#include "UITaskCloudAcquireInstances.h"
-
-
-UITaskCloudAcquireInstances::UITaskCloudAcquireInstances(const CCloudClient &comCloudClient, UIChooserNode *pParentNode)
-    : UITask(Type_CloudAcquireInstances)
-    , m_comCloudClient(comCloudClient)
-    , m_pParentNode(pParentNode)
-{
-}
-
-QVector<CCloudMachine> UITaskCloudAcquireInstances::result() const
-{
-    m_mutex.lock();
-    const QVector<CCloudMachine> resultVector = m_result;
-    m_mutex.unlock();
-    return resultVector;
-}
-
-QString UITaskCloudAcquireInstances::errorInfo()
-{
-    m_mutex.lock();
-    QString strErrorInfo = m_strErrorInfo;
-    m_mutex.unlock();
-    return strErrorInfo;
-}
-
-void UITaskCloudAcquireInstances::run()
-{
-    m_mutex.lock();
-    m_result = listCloudMachines(m_comCloudClient, m_strErrorInfo);
-    m_mutex.unlock();
-}
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h	(revision 83658)
+++ 	(revision )
@@ -1,83 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UITaskCloudAcquireInstances class declaration.
- */
-
-/*
- * Copyright (C) 2020 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef FEQT_INCLUDED_SRC_manager_UITaskCloudAcquireInstances_h
-#define FEQT_INCLUDED_SRC_manager_UITaskCloudAcquireInstances_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/* Qt includes: */
-#include <QMutex>
-
-/* GUI includes: */
-#include "UITask.h"
-
-/* COM includes: */
-#include "COMEnums.h"
-#include "CCloudClient.h"
-#include "CCloudMachine.h"
-
-/* Forward declaratiuons: */
-class UIChooserNode;
-
-/** UITask extension used to load cloud instance list. */
-class UITaskCloudAcquireInstances : public UITask
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs update task taking @a comCloudClient and @a pParentNode as data.
-      * @param  comCloudClient  Brings the cloud client object.
-      * @param  m_pParentNode   Brings the parent node reference. */
-    UITaskCloudAcquireInstances(const CCloudClient &comCloudClient, UIChooserNode *pParentNode);
-
-    /** Returns cloud client object. */
-    CCloudClient cloudClient() const { return m_comCloudClient; }
-    /** Returns parent node reference. */
-    UIChooserNode *parentNode() const { return m_pParentNode; }
-
-    /** Returns error info. */
-    QString errorInfo();
-
-    /** Returns the task result. */
-    QVector<CCloudMachine> result() const;
-
-protected:
-
-    /** Contains the task body. */
-    virtual void run() /* override */;
-
-private:
-
-    /** Holds the mutex to access result. */
-    mutable QMutex  m_mutex;
-
-    /** Holds the cloud client object. */
-    CCloudClient   m_comCloudClient;
-    /** Holds the parent node reference. */
-    UIChooserNode *m_pParentNode;
-
-    /** Holds the error info. */
-    QString  m_strErrorInfo;
-
-    /** Holds the task result. */
-    QVector<CCloudMachine>  m_result;
-};
-
-#endif /* !FEQT_INCLUDED_SRC_manager_UITaskCloudAcquireInstances_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudListMachines.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudListMachines.cpp	(revision 83659)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudListMachines.cpp	(revision 83659)
@@ -0,0 +1,51 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UITaskCloudListMachines class implementation.
+ */
+
+/*
+ * Copyright (C) 2020 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* GUI includes: */
+#include "UICloudNetworkingStuff.h"
+#include "UITaskCloudListMachines.h"
+
+
+UITaskCloudListMachines::UITaskCloudListMachines(const CCloudClient &comCloudClient, UIChooserNode *pParentNode)
+    : UITask(Type_CloudAcquireInstances)
+    , m_comCloudClient(comCloudClient)
+    , m_pParentNode(pParentNode)
+{
+}
+
+QVector<CCloudMachine> UITaskCloudListMachines::result() const
+{
+    m_mutex.lock();
+    const QVector<CCloudMachine> resultVector = m_result;
+    m_mutex.unlock();
+    return resultVector;
+}
+
+QString UITaskCloudListMachines::errorInfo() const
+{
+    m_mutex.lock();
+    QString strErrorInfo = m_strErrorInfo;
+    m_mutex.unlock();
+    return strErrorInfo;
+}
+
+void UITaskCloudListMachines::run()
+{
+    m_mutex.lock();
+    m_result = listCloudMachines(m_comCloudClient, m_strErrorInfo);
+    m_mutex.unlock();
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudListMachines.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudListMachines.h	(revision 83659)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudListMachines.h	(revision 83659)
@@ -0,0 +1,83 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UITaskCloudListMachines class declaration.
+ */
+
+/*
+ * Copyright (C) 2020 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef FEQT_INCLUDED_SRC_manager_UITaskCloudListMachines_h
+#define FEQT_INCLUDED_SRC_manager_UITaskCloudListMachines_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* Qt includes: */
+#include <QMutex>
+
+/* GUI includes: */
+#include "UITask.h"
+
+/* COM includes: */
+#include "COMEnums.h"
+#include "CCloudClient.h"
+#include "CCloudMachine.h"
+
+/* Forward declaratiuons: */
+class UIChooserNode;
+
+/** UITask extension used to list cloud machines. */
+class UITaskCloudListMachines : public UITask
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs update task taking @a comCloudClient and @a pParentNode as data.
+      * @param  comCloudClient  Brings the cloud client object.
+      * @param  m_pParentNode   Brings the parent node reference. */
+    UITaskCloudListMachines(const CCloudClient &comCloudClient, UIChooserNode *pParentNode);
+
+    /** Returns cloud client object. */
+    CCloudClient cloudClient() const { return m_comCloudClient; }
+    /** Returns parent node reference. */
+    UIChooserNode *parentNode() const { return m_pParentNode; }
+
+    /** Returns error info. */
+    QString errorInfo() const;
+
+    /** Returns the task result. */
+    QVector<CCloudMachine> result() const;
+
+protected:
+
+    /** Contains the task body. */
+    virtual void run() /* override */;
+
+private:
+
+    /** Holds the mutex to access result. */
+    mutable QMutex  m_mutex;
+
+    /** Holds the cloud client object. */
+    CCloudClient   m_comCloudClient;
+    /** Holds the parent node reference. */
+    UIChooserNode *m_pParentNode;
+
+    /** Holds the error info. */
+    QString  m_strErrorInfo;
+
+    /** Holds the task result. */
+    QVector<CCloudMachine>  m_result;
+};
+
+#endif /* !FEQT_INCLUDED_SRC_manager_UITaskCloudListMachines_h */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83658)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83659)
@@ -29,5 +29,5 @@
 #include "UIVirtualMachineItem.h"
 #ifdef VBOX_GUI_WITH_CLOUD_VMS
-# include "UITaskCloudAcquireInstances.h"
+# include "UITaskCloudListMachines.h"
 # include "UIThreadPool.h"
 # include "UIVirtualMachineItemCloud.h"
@@ -274,5 +274,5 @@
 
     /* Cast task to corresponding sub-class: */
-    UITaskCloudAcquireInstances *pAcquiringTask = static_cast<UITaskCloudAcquireInstances*>(pTask);
+    UITaskCloudListMachines *pAcquiringTask = static_cast<UITaskCloudListMachines*>(pTask);
 
     /* Make sure there were no errors: */
@@ -494,6 +494,6 @@
 
                                     /* Create cloud acquire isntances task: */
-                                    UITaskCloudAcquireInstances *pTask = new UITaskCloudAcquireInstances(comCloudClient,
-                                                                                                         pProfileNode);
+                                    UITaskCloudListMachines *pTask = new UITaskCloudListMachines(comCloudClient,
+                                                                                                 pProfileNode);
                                     if (pTask)
                                     {