Index: trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 83696)
+++ trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 83697)
@@ -2222,7 +2222,7 @@
     , m_iXSpacing(5)
     , m_iYSpacing(5)
-    , m_iLeftMargin(10)
+    , m_iLeftMargin(0)
     , m_iTopMargin(10)
-    , m_iRightMargin(10)
+    , m_iRightMargin(0)
     , m_iBottomMargin(10)
     , m_enmMode(Mode_Keyboard)
@@ -2305,4 +2305,9 @@
             else
                 painter.translate(key.keyGeometry().x(), key.keyGeometry().y());
+
+            int m_iBeforeNumPadWidth = 0;
+
+            if (key.keyboardRegion() == KeyboardRegion_NumPad)
+                painter.translate(m_iBeforeNumPadWidth, 0);
 
             if(&key  == m_pKeyBeingEdited)
@@ -2344,5 +2349,6 @@
             else
                 painter.translate(-key.keyGeometry().x(), -key.keyGeometry().y());
-
+            if (key.keyboardRegion() == KeyboardRegion_NumPad)
+                painter.translate(- m_iBeforeNumPadWidth, 0);
         }
     }
@@ -3014,5 +3020,5 @@
                     iXNoNumPad += m_iXSpacing;
                 if (key.spaceWidthAfter() != 0)
-                    iXNoNumPad += (m_iXSpacing + key.spaceWidthAfter());
+                    iXNoNumPad += key.spaceWidthAfter();
             }
         }
@@ -3031,5 +3037,4 @@
     m_iInitialWidthNoNumPad = qMax(m_iInitialWidthNoNumPad, iInitialWidthNoNumPad);
     m_iInitialHeight = qMax(m_iInitialHeight, iInitialHeight);
-
     return true;
 }
Index: trunk/src/VBox/Frontends/VirtualBox/xml/101_ansi.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/101_ansi.xml	(revision 83696)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/101_ansi.xml	(revision 83697)
@@ -230,7 +230,4 @@
             <scancode>0x49</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -345,7 +342,4 @@
             <scancodeprefix>0xe0</scancodeprefix>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -434,5 +428,5 @@
         </key>
         <space>
-            <width>220</width>
+            <width>190</width>
         </space>
     </row>
@@ -440,5 +434,4 @@
         <key>
             <width>125</width>
-
             <usageid>0xe1</usageid>
             <usagepage>0x7</usagepage>
@@ -528,5 +521,5 @@
         </key>
         <space>
-            <width>80</width>
+            <width>50</width>
         </space>
     </row>
@@ -632,7 +625,4 @@
             <scancode>0x4d</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
 </physicallayout>
Index: trunk/src/VBox/Frontends/VirtualBox/xml/102_iso.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/102_iso.xml	(revision 83696)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/102_iso.xml	(revision 83697)
@@ -231,7 +231,4 @@
             <scancode>0x49</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -353,7 +350,4 @@
             <scancodeprefix>0xe0</scancodeprefix>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -439,5 +433,5 @@
         </key>
         <space>
-            <width>285</width>
+            <width>255</width>
         </space>
     </row>
@@ -537,5 +531,5 @@
         </key>
         <space>
-            <width>80</width>
+            <width>50</width>
         </space>
     </row>
@@ -640,7 +634,4 @@
             <scancode>0x4d</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
 </physicallayout>
Index: trunk/src/VBox/Frontends/VirtualBox/xml/103_ansi.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/103_ansi.xml	(revision 83696)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/103_ansi.xml	(revision 83697)
@@ -228,7 +228,4 @@
             <scancode>0x49</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -343,7 +340,4 @@
             <scancodeprefix>0xe0</scancodeprefix>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -432,5 +426,5 @@
         </key>
         <space>
-            <width>220</width>
+            <width>190</width>
         </space>
     </row>
@@ -526,5 +520,5 @@
         </key>
         <space>
-            <width>80</width>
+            <width>50</width>
         </space>
     </row>
@@ -639,7 +633,4 @@
             <scancode>0x4d</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
 </physicallayout>
Index: trunk/src/VBox/Frontends/VirtualBox/xml/103_iso.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/103_iso.xml	(revision 83696)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/103_iso.xml	(revision 83697)
@@ -231,7 +231,4 @@
             <scancode>0x49</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -353,7 +350,4 @@
             <scancodeprefix>0xe0</scancodeprefix>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -439,5 +433,5 @@
         </key>
         <space>
-            <width>285</width>
+            <width>255</width>
         </space>
     </row>
@@ -542,5 +536,5 @@
         </key>
         <space>
-            <width>80</width>
+            <width>50</width>
         </space>
     </row>
@@ -643,7 +637,4 @@
             <scancode>0x4d</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
 </physicallayout>
Index: trunk/src/VBox/Frontends/VirtualBox/xml/106_japanese.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/106_japanese.xml	(revision 83696)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/106_japanese.xml	(revision 83697)
@@ -237,7 +237,4 @@
             <scancode>0x49</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -359,7 +356,4 @@
             <scancodeprefix>0xe0</scancodeprefix>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
     <row>
@@ -445,5 +439,5 @@
         </key>
         <space>
-            <width>285</width>
+            <width>255</width>
         </space>
     </row>
@@ -543,5 +537,5 @@
         </key>
         <space>
-            <width>80</width>
+            <width>50</width>
         </space>
     </row>
@@ -661,7 +655,4 @@
             <scancode>0x4d</scancode>
         </key>
-        <space>
-            <width>25</width>
-        </space>
     </row>
 </physicallayout>